diff --git a/src/org/apache/xerces/impl/xpath/regex/RegularExpression.java b/src/org/apache/xerces/impl/xpath/regex/RegularExpression.java
index 4a0cbbb..d2f068c 100644
--- a/src/org/apache/xerces/impl/xpath/regex/RegularExpression.java
+++ b/src/org/apache/xerces/impl/xpath/regex/RegularExpression.java
@@ -2967,7 +2201,7 @@ public class RegularExpression implements java.io.Serializable {
      * @exception org.apache.xerces.utils.regex.ParseException <VAR>regex</VAR> is not conforming to the syntax.
      */
     public RegularExpression(String regex) throws ParseException {
-        this.setPattern(regex, null);
+        this(regex, null);
     }
 
     /**
@@ -2980,6 +2214,17 @@ public class RegularExpression implements java.io.Serializable {
     public RegularExpression(String regex, String options) throws ParseException {
         this.setPattern(regex, options);
     }
+    
+    /**
+     * Creates a new RegularExpression instance with options.
+     *
+     * @param regex A regular expression
+     * @param options A String consisted of "i" "m" "s" "u" "w" "," "X"
+     * @exception org.apache.xerces.utils.regex.ParseException <VAR>regex</VAR> is not conforming to the syntax.
+     */
+    public RegularExpression(String regex, String options, Locale locale) throws ParseException {
+        this.setPattern(regex, options, locale);
+    }
 
     RegularExpression(String regex, Token tok, int parens, boolean hasBackReferences, int options) {
         this.regex = regex;
@@ -2993,14 +2238,18 @@ public class RegularExpression implements java.io.Serializable {
      *
      */
     public void setPattern(String newPattern) throws ParseException {
-        this.setPattern(newPattern, this.options);
+        this.setPattern(newPattern, Locale.getDefault());
+    }
+    
+    public void setPattern(String newPattern, Locale locale) throws ParseException {
+        this.setPattern(newPattern, this.options, locale);
     }
 
-    private void setPattern(String newPattern, int options) throws ParseException {
+    private void setPattern(String newPattern, int options, Locale locale) throws ParseException {
         this.regex = newPattern;
         this.options = options;
         RegexParser rp = RegularExpression.isSet(this.options, RegularExpression.XMLSCHEMA_MODE)
-                         ? new ParserForXMLSchema() : new RegexParser();
+                         ? new ParserForXMLSchema(locale) : new RegexParser(locale);
         this.tokentree = rp.parse(this.regex, this.options);
         this.nofparen = rp.parennumber;
         this.hasBackReferences = rp.hasBackReferences;
@@ -3012,7 +2261,11 @@ public class RegularExpression implements java.io.Serializable {
      *
      */
     public void setPattern(String newPattern, String options) throws ParseException {
-        this.setPattern(newPattern, REUtil.parseOptions(options));
+        this.setPattern(newPattern, options, Locale.getDefault());
+    }
+    
+    public void setPattern(String newPattern, String options, Locale locale) throws ParseException {
+        this.setPattern(newPattern, REUtil.parseOptions(options), locale);
     }
 
     /**
